# Data class in python
# are used to mitigate the need to write init, eq, repr, etc.
# The dataclass decorator automatically generates special methods for you.

from dataclasses import dataclass

# In this example, the Rectangle class is defined as a data class. 
# Changes are allowed to the width and height of the rectangle.
# The __eq__ method is automatically generated by the dataclass decorator.
# The __str__ method is automatically generated by the dataclass decorator.
# The __repr__ method is automatically generated by the dataclass decorator.
# The __hash__ method is automatically generated by the dataclass decorator. etc 
@dataclass()
class Rectangle:
    width: float # type annotation is needed for dataclass
    height: float # type annotation is needed for dataclass

    # Instance methods
    def area(self):
        return self.width * self.height

    def perimeter(self):
        return 2 * (self.width + self.height)

# In this example, the Rectangle class is defined as a data class.
# Changes are not allowed to the width and height of the rectangle.
# They become immutable
@dataclass(frozen=True)
class RectangleUnchangeable:
    width: float
    height: float

    def area(self):
        return self.width * self.height

    def perimeter(self):
        return 2 * (self.width + self.height)
    
# Usage
r1 = Rectangle(3, 4.9)
r2 = Rectangle(5, 6.7)

print(r1 == r2) # False
print(r2 == Rectangle(5, 6.7)) # True

print(r1) # Rectangle(width=3, height=4.9)
r1.width = 10 # change the width of r1 is possible
print(r1) # Rectangle(width=10, height=4.9)

# Usage of the frozen=True parameter
r3 = RectangleUnchangeable(3, 4.9)
r4 = RectangleUnchangeable(5, 6.7)

set = {r3, r4} # Allowed because the class has hash method
print(r3 in set) # True
print(r4 in set) # True
print(set)
# r3.width = 10 # raises an error
